=== debian/changelog ===
qv2ray (2.7.0~alpha3-1) unstable; urgency=medium

  * New upstream release 2.7.0-alpha3
    * add: added connection template settings entry
    * fix: quit after a new version has been detected
    * update backend.cmake
    * 😢
    * fallback to pkgconfig if gRPC doesn't build by cmake
    * update build-qv2ray-cmake.yml
    * use find_package method to find gRPC for macOS
    * fix: remove h2 in ALPN
    * fix: fixed build
    * add: added importing all connections, closes #1003
    * fix: fixed build and cleanup
    * update: update Qv2rayApplicationInterface interface
    * fix: use TextChanged instead of IndexChanged
    * rebuild: trigger rebuild
    * version: bumped version suffix
    * updating translations!
    * fix: fixed disableSystemRoot option
    * fix: added updateColorScheme for DNSSettingsWidget

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 19 Oct 2020 10:08:20 +0800

qv2ray (2.7.0~alpha2-1) unstable; urgency=medium

  * New upstream release 2.7.0-alpha2

 -- Guobang Bi <ymshenyu@gmail.com>  Fri, 09 Oct 2020 10:56:01 +0800

qv2ray (2.7.0~alpha1-1) unstable; urgency=medium

  * New upstream release 2.7.0-alpha1
  	* see details on https://www.github.com/Qv2ray/Qv2ray

 -- Guobang Bi <ymshenyu@gmail.com>  Sat, 19 Sep 2020 21:58:53 +0800

qv2ray (2.6.3-1) unstable; urgency=medium

  * add: added support for VLESS
  * add: support collapse all groups in one click
  * fix: fixed/refined new vmess share link parser
  * trying to save your brains

 -- Guobang Bi <ymshenyu@gmail.com>  Tue, 04 Aug 2020 20:37:13 +0800

qv2ray (2.6.2-1) unstable; urgency=medium

  * fix: changed VMess default user alterId to 32
  * add: enhanced StackTrace helper to collect more relavent data
  * feat: support to disable scrolling when viewing logs
  * re-implement ICMPing with libuv

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 20 Jul 2020 10:38:16 +0800

qv2ray (2.6.1-1) unstable; urgency=medium

  * fix: should not edit GroupManager tablewidget
  * fix: fixed connection import/export with unwanted content (Closes #771)
  * fix: fixed V2RAY_LOCATION_ASSET env name (Closes #768)
  * fix: QR code file cannot be imported

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 13 Jul 2020 09:37:27 +0800

qv2ray (2.6.0-1) unstable; urgency=medium

  * New Release 2.6.0

 -- Guobang Bi <ymshenyu@gmail.com>  Thu, 09 Jul 2020 22:04:57 +0800

qv2ray (2.6.0~rc6-1) unstable; urgency=medium

  * New Release 2.6.0-rc6

 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 08 Jul 2020 21:43:01 +0800

qv2ray (2.6.0~rc5-1) unstable; urgency=medium

  * New Release 2.6.0-rc5

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 06 Jul 2020 17:37:41 +0800

qv2ray (2.6.0~rc4-1) unstable; urgency=medium

  * fix: fixed ssd:// order issue, fixed #635
  * add: remove connections via delete key
  * add: added qv2ray://
  * add: use env QV2RAY_CONFIG_PATH to specify config path, make darkmode theme cross-platform, refactor
  * add: introducing Qv2rayApplication

 -- Guobang Bi <ymshenyu@gmail.com>  Thu, 18 Jun 2020 16:10:05 +0800

qv2ray (2.6.0~rc3-1) unstable; urgency=medium

  * add: added DNS Settings and GroupRouteManager
  * fix: bgcolor can't switch to default when swiching to flatwhite/psblack and then back to breeze or other
  * refactor: change include structure
  * fix: sort groups by displayName
  * fix: improve GroupManager performance by 5000%
  * fix: fixed Recent Connections jumplist
  * fix: fixed EMBED_TRANSLATIONS option
  * fix: prevent reading geosite/geoip every time
  * add: added ICMP as latency tester
  
 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 27 May 2020 18:17:03 +0800

qv2ray (2.6.0~rc2-1) unstable; urgency=medium

  * fix: fixed tcping message
  * refactor: refactored auto update algorithm
  * fix: fixed Windows non-block TCPing
  * fix: UI tweak, prevent connection list taking too much space

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 18 May 2020 12:01:50 +0800

qv2ray (2.6.0~rc1-1) unstable; urgency=medium

  * NTP Check
  * Port Detection
  * Introduce unit test
  * Introduce group editor/manager
  * added vmess v1 upgrader (close #609)
  * Refactor system proxy  

 -- Guobang Bi <ymshenyu@gmail.com>  Sun, 17 May 2020 20:23:35 +0800

qv2ray (2.5.0-1) unstable; urgency=medium

  * updating translations
  * add: added Latency Test on the connection list RCM, fixed #539
  * rejecting trash v2rayN vmess schema v1
  * add: use UseIP when tProxy and DNSIntercept have been enabled
  * fix: fixed a missing IPv6 CIDR address
  * fix: fixed a missing IP rule when proxy is disabled

 -- Guobang Bi <ymshenyu@gmail.com>  Sun, 26 Apr 2020 19:03:35 +0800

qv2ray (2.5.0~rc1-1) unstable; urgency=medium

  * add dns intercept and route for tproxy
  * prevent loopback
  * fix: allow dns outbound have mark too
  * fix: refactored Qv2ray Proxy settings

 -- Guobang Bi <ymshenyu@gmail.com>  Sat, 25 Apr 2020 10:29:07 +0800

qv2ray (2.5.0~pre2-1) unstable; urgency=medium

  * fix: skip saving config when importing multiple connection configs
  * add: ignore updating subscription by setting interval to 0
  * fix: fixed a missing signal emit
  * update: updated label text, fixed a spelling misATke
  * add: added kernel plugin support

 -- Guobang Bi <ymshenyu@gmail.com>  Sat, 11 Apr 2020 23:12:20 +0800

qv2ray (2.4.1-1) unstable; urgency=medium

  * add: add new semver checker
  * add: added support of ssd:// fixed #372
  * fix: apply tabStop sequences by @DuckSoft
  * fix: increase configuration save frequency
  * fix: fixed SOCKS user removal issue

 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 01 Apr 2020 14:51:15 +0800

qv2ray (2.4.0~pre1-1) unstable; urgency=medium

  * change: ported to zxing-cpp
  * fixed: fixed #else condition in DISABLE_AUTO_UPDATE
  * fix: fixed domainStrategy export and MainWindow button icon color scheme change event

 -- Guobang Bi <ymshenyu@gmail.com>  Fri, 27 Mar 2020 23:15:16 +0800

qv2ray (2.3.2-1) unstable; urgency=medium

  * Fix Strange Button Length

 -- Guobang Bi <ymshenyu@gmail.com>  Sun, 22 Mar 2020 20:33:31 +0800


